#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi
# Template for PureMessage Webmin Modules

use HTML::Template;
use PureMessage::Version qw($VERSION $PREFIX);
use PureMessage::Manager::Widget::ToolBar;
use PureMessage::Manager::Request qw($REQUEST);
use PureMessage::Manager::Response::Support::ShareData;
use PureMessage::Manager::Lang;
use PureMessage::Scheduler::Config;
use PureMessage::Service::Config qw(is_stale);
use strict;

my  %vars;   # Template variables
my  %in;     # CGI parameters 

my $PMX_MLOG_STATS  = 'pmx-mlog-stats';
my $FEEDBACK_CHKBOX = 'feedback';
my $SAVED_SUBMIT    = 'Save';
my $HELP_URL        = 'mgr_support_sharedata';

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Support::ShareData',
#                               'stderr_to_stdout' =>1
                                );

$r->add_help(text => "Help", tab => "support", page => "mgr_support_sharedata" );
$r->title("Share Data With Sophos");

# Get CGI params
$in{$SAVED_SUBMIT}    = 1 if $REQUEST->query($SAVED_SUBMIT);
$in{$FEEDBACK_CHKBOX} = 1 if $REQUEST->query($FEEDBACK_CHKBOX);

# Populate our template variables
$vars{'EXAMPLE'} = $HELP_URL;
$vars{'FEEDBACK'} = $FEEDBACK_CHKBOX;
$vars{'HEADER'} = $r->ThemeSectionHeader(width=>'100%', 
                                         title=>text('Share data with Sophos'))->output;
my $tb = new PureMessage::Manager::Widget::ToolBar( name    => 'toolbar',
                                                    buttons => [ [{ type => 'image', 
                                                                    text=>'Save', 
                                                                    name=>'Save',
                                                                    icon=>'save.gif'
                                                                    }] ],
                                                    table    => [[2,2],[undef,undef]],
                                                    );
$vars{'FOOTER'} = $r->ThemeSectionFooter(toolbar=>$tb)->output();

# Determine whether the checkbox should be checked
my ($scheduler, $job_enabled);
eval {
    $scheduler    = PureMessage::Scheduler::Config->new( writable => 1 );
    $job_enabled  = $scheduler->is_enabled_event($PMX_MLOG_STATS);
};

if ($@) {
    print STDERR $@;
    $r->raise_error("Unable to read scheduler configuration");
    $r->send();
    exit;
}

$vars{'CHECKED'} = 'checked' if $job_enabled;

if (exists $in{$SAVED_SUBMIT}) { # Submitted
    my $req_status = (exists $in{$FEEDBACK_CHKBOX}) ? 1 : 0;
    $vars{'CHECKED'} = 'checked' if $req_status;
    unless(StatusChange($scheduler, $job_enabled, $req_status)) {
        putOkMesg();
    }
}
else { # Display main page
    putMainForm();
}

$r->send();
exit;

sub putMainForm {
    my $SET_DEFAULT_FOCUS = q|document.forms[0].elements[0].focus()|;
    $r->{body_attrib}->{onload} = $SET_DEFAULT_FOCUS; 
    $r->addRestartDlg();
    $r->add_template( file=>'tmpl/index.html', data=>\%vars, die_on_bad_params => 0);
}

sub putOkMesg {
    $r->addRestartDlg();
    $r->dialog( width=>'100%', style=> 'dlg_info', msg => 'Your changes have been saved', title => "ok");
}

sub StatusChange {
    my ($scheduler, $act_status, $req_status) = @_;

    # It we are changing state, make the change, else do nothing
    if ($act_status != $req_status) {
        my $op = ($req_status) ? 'enable_event' : 'disable_event';
        my $post_status = 0;
        eval { 
            $scheduler->$op($PMX_MLOG_STATS);
            $scheduler->save();
            $scheduler->refresh();
            $post_status = $scheduler->is_enabled_event($PMX_MLOG_STATS);
        };

        # The scheduler doesn't always error when it fails to save
        if ($@ || ($post_status != $req_status) ) {
            print STDERR $@ if $@;
            $r->raise_error("Unable to modify scheduler job");
            return 1;
        }
    }
    return 0;
}

