package PureMessage::Marks;
use strict;
use warnings;
use base 'Exporter';
our @EXPORT_OK = qw(is_internal_mark is_external_mark is_custom_mark);

my %INTERNAL_MARKS = map { $_ => 1 } 
    qw(a at b d f fur g h i p q r size t test-id tm time_stamp v vs pmx_reason
       pmx_action S s);

sub is_internal_mark { 
    my $m = shift;
    return 1 if exists $INTERNAL_MARKS{$m} || is_custom_mark($m);
    return 0;
}

sub is_external_mark { !is_internal_mark(shift) }

sub is_custom_mark {
    my $m = shift;
    return $1 if $m =~ m/^crpt_(.+)/;
    return;
}

1;
