package PureMessage::MessageLog::Watch::Config;
use strict;
use warnings;
use ActiveState::Config qw(:path);
use PureMessage::Config qw(expand_config_filename);

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my %data = @_;

    my $as = ActiveState::Config->new();
    $as->parse_file(expand_config_filename('logwatch'), 'writable'=> 1);
    $data{'conf'} = $as;
    return bless \%data, $class;
}

sub as_hash() { shift->{'conf'}->as_hash }

sub val {
    my ($self, $key, $val) = @_;
    path_value($self->{'conf'}->root, $key, $val) if $val;
    return path_value($self->{'conf'}->root, $key);
}

sub save { shift->{'conf'}->save }

1;
